diff --git a/conn.c b/conn.c
index 0d06ce11..32cbcd34 100644
--- a/conn.c
+++ b/conn.c
@@ -209,16 +209,18 @@ conn_ready(Conn *c)
 
 
 int
-connless(Conn *a, Conn *b)
+conn_less(void *ca, void *cb)
 {
+    Conn *a = (Conn *)ca;
+    Conn *b = (Conn *)cb;
     return a->tickat < b->tickat;
 }
 
 
 void
-connrec(Conn *c, size_t i)
+conn_setpos(void *c, size_t i)
 {
-    c->tickpos = i;
+    ((Conn *)c)->tickpos = i;
 }
 
 
diff --git a/dat.h b/dat.h
index 5c7cd653..6f02a351 100644
--- a/dat.h
+++ b/dat.h
@@ -26,8 +26,6 @@ typedef struct Wal    Wal;
 
 typedef void(*ms_event_fn)(ms a, void *item, size_t i);
 typedef void(*Handle)(void*, int rw);
-typedef int(*Less)(void*, void*);
-typedef void(*Record)(void*, size_t);
 typedef int(FAlloc)(int, int);
 
 
@@ -103,12 +101,20 @@ struct stats {
 };
 
 
+// less_fn is used by the binary heap to determine the order of elements.
+typedef int(*less_fn)(void*, void*);
+
+// setpos_fn is used by the binary heap to record the new positions of elements
+// whenever they get moved or inserted.
+typedef void(*setpos_fn)(void*, size_t);
+
 struct Heap {
-    size_t  cap;
-    size_t  len;
-    void    **data;
-    Less    less;
-    Record  rec;
+    size_t  cap;                // capacity of the heap
+    size_t  len;                // amount of elements in the heap
+    void    **data;             // actual elements
+
+    less_fn   less;
+    setpos_fn setpos;
 };
 int   heapinsert(Heap *h, void *x);
 void* heapremove(Heap *h, size_t k);
@@ -237,9 +243,9 @@ void job_free(job j);
 job job_find(uint64 job_id);
 
 /* the void* parameters are really job pointers */
-void job_setheappos(void*, size_t);
-int job_pri_less(void*, void*);
-int job_delay_less(void*, void*);
+void job_setpos(void *j, size_t i);
+int job_pri_less(void *ja, void *jb);
+int job_delay_less(void *ja, void *jb);
 
 job job_copy(job j);
 
@@ -329,8 +335,8 @@ struct Conn {
     struct ms  watch;
     struct job reserved_jobs; // linked list header
 };
-int  connless(Conn *a, Conn *b);
-void connrec(Conn *c, size_t i);
+int  conn_less(void *ax, void *bx);
+void conn_setpos(void *cx, size_t i);
 void connwant(Conn *c, int rw);
 void connsched(Conn *c);
 void connclose(Conn *c);
diff --git a/heap.c b/heap.c
index dd818a23..e3ce0ba2 100644
--- a/heap.c
+++ b/heap.c
@@ -8,7 +8,7 @@ static void
 set(Heap *h, size_t k, void *x)
 {
     h->data[k] = x;
-    h->rec(x, k);
+    h->setpos(x, k);
 }
 
 
diff --git a/job.c b/job.c
index 5abe8804..673d0b5b 100644
--- a/job.c
+++ b/job.c
@@ -158,24 +158,26 @@ job_free(job j)
 }
 
 void
-job_setheappos(void *j, size_t pos)
+job_setpos(void *j, size_t pos)
 {
     ((job)j)->heap_index = pos;
 }
 
 int
-job_pri_less(void *ax, void *bx)
+job_pri_less(void *ja, void *jb)
 {
-    job a = ax, b = bx;
+    job a = (job)ja;
+    job b = (job)jb;
     if (a->r.pri < b->r.pri) return 1;
     if (a->r.pri > b->r.pri) return 0;
     return a->r.id < b->r.id;
 }
 
 int
-job_delay_less(void *ax, void *bx)
+job_delay_less(void *ja, void *jb)
 {
-    job a = ax, b = bx;
+    job a = ja;
+    job b = jb;
     if (a->r.deadline_at < b->r.deadline_at) return 1;
     if (a->r.deadline_at > b->r.deadline_at) return 0;
     return a->r.id < b->r.id;
diff --git a/serv.c b/serv.c
index 20d1ed0c..eb41900a 100644
--- a/serv.c
+++ b/serv.c
@@ -25,8 +25,8 @@ srvserve(Server *s)
 
     s->sock.x = s;
     s->sock.f = (Handle)srvaccept;
-    s->conns.less = (Less)connless;
-    s->conns.rec = (Record)connrec;
+    s->conns.less = conn_less;
+    s->conns.setpos = conn_setpos;
 
     r = listen(s->sock.fd, 1024);
     if (r == -1) {
diff --git a/testheap.c b/testheap.c
index 6d4209a1..5920d800 100644
--- a/testheap.c
+++ b/testheap.c
@@ -12,7 +12,7 @@ cttest_heap_insert_one()
 {
     Heap h = {
         .less = job_pri_less,
-        .rec = job_setheappos,
+        .setpos = job_setpos,
     };
 
     job j = make_job(1, 0, 1, 0, 0);
@@ -28,7 +28,7 @@ cttest_heap_insert_and_remove_one()
 {
     Heap h = {
         .less = job_pri_less,
-        .rec = job_setheappos,
+        .setpos = job_setpos,
     };
 
     job j1 = make_job(1, 0, 1, 0, 0);
@@ -47,7 +47,7 @@ cttest_heap_priority()
 {
     Heap h = {
         .less = job_pri_less,
-        .rec = job_setheappos,
+        .setpos = job_setpos,
     };
     job j, j1, j2, j3;
 
@@ -91,7 +91,7 @@ cttest_heap_fifo_property()
 {
     Heap h = {
         .less = job_pri_less,
-        .rec = job_setheappos,
+        .setpos = job_setpos,
     };
     job j, j3a, j3b, j3c;
 
@@ -138,7 +138,7 @@ cttest_heap_many_jobs()
 {
     Heap h = {
         .less = job_pri_less,
-        .rec = job_setheappos,
+        .setpos = job_setpos,
     };
     const int n = 20;
     job j;
@@ -164,7 +164,7 @@ cttest_heap_remove_k()
 {
     Heap h = {
         .less = job_pri_less,
-        .rec = job_setheappos,
+        .setpos = job_setpos,
     };
     const int n = 20;
 
@@ -203,7 +203,7 @@ ctbench_heap_insert(int n)
     }
     Heap h = {
         .less = job_pri_less,
-        .rec = job_setheappos,
+        .setpos = job_setpos,
     };
     ctresettimer();
     for (i = 0; i < n; i++) {
@@ -216,7 +216,7 @@ ctbench_heap_remove(int n)
 {
     Heap h = {
         .less = job_pri_less,
-        .rec = job_setheappos,
+        .setpos = job_setpos,
     };
 
     int i;
diff --git a/tube.c b/tube.c
index 38ac6a08..cc7bab69 100644
--- a/tube.c
+++ b/tube.c
@@ -19,8 +19,8 @@ make_tube(const char *name)
 
     t->ready.less = job_pri_less;
     t->delay.less = job_delay_less;
-    t->ready.rec = job_setheappos;
-    t->delay.rec = job_setheappos;
+    t->ready.setpos = job_setpos;
+    t->delay.setpos = job_setpos;
 
     struct job j = {.tube = NULL};
     t->buried = j;
